# $FreeBSD$

LCRYPTO_SRC=	${.CURDIR}/../../../crypto/openssl/crypto
CFLAGS+= -DTERMIOS -DANSI_SOURCE -DNO_IDEA -I${LCRYPTO_SRC} -I${.OBJDIR}

.if ${MACHINE_ARCH} == "i386"
CFLAGS+= -DL_ENDIAN
# -DBN_ASM -DSHA1_ASM -DMD5_ASM -DRMD160_ASM - XXX notyet
.elif ${MACHINE_ARCH} == "alpha"
# no ENDIAN stuff defined for alpha (64-bit)
.endif

WITH_RSA?= YES

SRCS+=		buildinf.h openssl/opensslconf.h
CLEANFILES+=	buildinf.h openssl/opensslconf.h
CLEANDIRS+=	openssl

buildinf.h:
	( echo "#ifndef MK1MF_BUILD"; \
	echo "  /* auto-generated by crypto/Makefile.ssl for crypto/cversion.c */"; \
	echo "  #define CFLAGS \"$(CC)\""; \
	echo "  #define PLATFORM \"`uname -s`-`uname -m`\""; \
	echo "  #define DATE \"`LC_TIME=C date`\""; \
	echo "#endif" ) > ${.TARGET}

#	XXX:  The openssl/ dependencies are not correct, in that a change in
#	any of ${CRYPTO_HDRS} ${EXTRA_HDRS} will no repopulate openssl/.
#	This deficiency will be fixed in a later commit.

openssl/opensslconf.h:  ../libcrypto/opensslconf-${MACHINE_ARCH}.h
	mkdir -p openssl
	cp ${.OODATE} ${.TARGET}
	${INSTALL} ${COPY} -m 444 ${CRYPTO_HDRS} ${EXTRA_HDRS} openssl
